/* iconwidget.c generated by valac 0.40.8, the Vala compiler
 * generated from iconwidget.vala, do not modify */

/* vim:set et sts=4 sw=4:
 *
 * ibus - The Input Bus
 *
 * Copyright(c) 2011-2014 Peng Huang <shawn.p.huang@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301
 * USA
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>


#define TYPE_ICON_WIDGET (icon_widget_get_type ())
#define ICON_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON_WIDGET, IconWidget))
#define ICON_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON_WIDGET, IconWidgetClass))
#define IS_ICON_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON_WIDGET))
#define IS_ICON_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON_WIDGET))
#define ICON_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON_WIDGET, IconWidgetClass))

typedef struct _IconWidget IconWidget;
typedef struct _IconWidgetClass IconWidgetClass;
typedef struct _IconWidgetPrivate IconWidgetPrivate;
enum  {
	ICON_WIDGET_0_PROPERTY,
	ICON_WIDGET_NUM_PROPERTIES
};
static GParamSpec* icon_widget_properties[ICON_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _IconWidget {
	GtkImage parent_instance;
	IconWidgetPrivate * priv;
};

struct _IconWidgetClass {
	GtkImageClass parent_class;
};


static gpointer icon_widget_parent_class = NULL;

GType icon_widget_get_type (void) G_GNUC_CONST;
IconWidget* icon_widget_new (const gchar* icon_name_or_path,
                             GtkIconSize size);
IconWidget* icon_widget_construct (GType object_type,
                                   const gchar* icon_name_or_path,
                                   GtkIconSize size);


/**
     * IconWidget:
     * @icon_name_or_path: Can be a name or path but not stock id
     *     because gtk_icon_theme_load_icon() cannot fallback the
     *     stock id to a real file name against
     *     gtk_image_new_from_stock().
     * @size: #Gtk.IconSize
     */
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


IconWidget*
icon_widget_construct (GType object_type,
                       const gchar* icon_name_or_path,
                       GtkIconSize size)
{
	IconWidget * self = NULL;
	GdkPixbuf* pixbuf = NULL;
	gint fixed_width = 0;
	gint fixed_height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GdkPixbuf* _tmp19_;
	gfloat width = 0.0F;
	GdkPixbuf* _tmp20_;
	gfloat height = 0.0F;
	GdkPixbuf* _tmp21_;
	gfloat _tmp22_ = 0.0F;
	gfloat _tmp23_;
	gfloat _tmp24_;
	gfloat scale = 0.0F;
	gint _tmp27_;
	gfloat _tmp28_;
	gfloat _tmp29_;
	gfloat _tmp30_;
	gfloat _tmp31_;
	GdkPixbuf* _tmp32_;
	gfloat _tmp33_;
	gfloat _tmp34_;
	GdkPixbuf* _tmp35_;
	GdkPixbuf* _tmp36_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (icon_name_or_path != NULL, NULL);
	self = (IconWidget*) g_object_new (object_type, NULL);
	pixbuf = NULL;
	gtk_icon_size_lookup (size, &_tmp0_, &_tmp1_);
	fixed_width = _tmp0_;
	fixed_height = _tmp1_;
	{
		if (string_get (icon_name_or_path, (glong) 0) == '/') {
			GdkPixbuf* _tmp2_ = NULL;
			GdkPixbuf* _tmp3_;
			GdkPixbuf* _tmp4_;
			_tmp3_ = gdk_pixbuf_new_from_file (icon_name_or_path, &_inner_error_);
			_tmp2_ = _tmp3_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch2_g_error;
			}
			_tmp4_ = _tmp2_;
			_tmp2_ = NULL;
			_g_object_unref0 (pixbuf);
			pixbuf = _tmp4_;
			_g_object_unref0 (_tmp2_);
		} else {
			GtkIconTheme* theme = NULL;
			GtkIconTheme* _tmp5_;
			GtkIconTheme* _tmp6_;
			GdkPixbuf* _tmp7_ = NULL;
			GtkIconTheme* _tmp8_;
			gint _tmp9_;
			GdkPixbuf* _tmp10_;
			GdkPixbuf* _tmp11_;
			_tmp5_ = gtk_icon_theme_get_default ();
			_tmp6_ = _g_object_ref0 (_tmp5_);
			theme = _tmp6_;
			_tmp8_ = theme;
			_tmp9_ = fixed_width;
			_tmp10_ = gtk_icon_theme_load_icon (_tmp8_, icon_name_or_path, _tmp9_, 0, &_inner_error_);
			_tmp7_ = _tmp10_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (theme);
				goto __catch2_g_error;
			}
			_tmp11_ = _tmp7_;
			_tmp7_ = NULL;
			_g_object_unref0 (pixbuf);
			pixbuf = _tmp11_;
			_g_object_unref0 (_tmp7_);
			_g_object_unref0 (theme);
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			GtkIconTheme* theme = NULL;
			GtkIconTheme* _tmp12_;
			GtkIconTheme* _tmp13_;
			GdkPixbuf* _tmp14_ = NULL;
			GtkIconTheme* _tmp15_;
			gint _tmp16_;
			GdkPixbuf* _tmp17_;
			GdkPixbuf* _tmp18_;
			_tmp12_ = gtk_icon_theme_get_default ();
			_tmp13_ = _g_object_ref0 (_tmp12_);
			theme = _tmp13_;
			_tmp15_ = theme;
			_tmp16_ = fixed_width;
			_tmp17_ = gtk_icon_theme_load_icon (_tmp15_, "ibus-engine", _tmp16_, 0, &_inner_error_);
			_tmp14_ = _tmp17_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (theme);
				goto __catch3_g_error;
			}
			_tmp18_ = _tmp14_;
			_tmp14_ = NULL;
			_g_object_unref0 (pixbuf);
			pixbuf = _tmp18_;
			_g_object_unref0 (_tmp14_);
			_g_object_unref0 (theme);
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError* e = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			gtk_image_set_from_icon_name ((GtkImage*) self, "image-missing", (GtkIconSize) size);
			_g_error_free0 (e);
			_g_error_free0 (e);
			_g_object_unref0 (pixbuf);
			return self;
		}
		__finally3:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_error_free0 (e);
			_g_error_free0 (e);
			_g_object_unref0 (pixbuf);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_g_error_free0 (e);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (pixbuf);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp19_ = pixbuf;
	if (_tmp19_ == NULL) {
		_g_object_unref0 (pixbuf);
		return self;
	}
	_tmp20_ = pixbuf;
	width = (gfloat) gdk_pixbuf_get_width (_tmp20_);
	_tmp21_ = pixbuf;
	height = (gfloat) gdk_pixbuf_get_height (_tmp21_);
	_tmp23_ = width;
	_tmp24_ = height;
	if (_tmp23_ > _tmp24_) {
		gfloat _tmp25_;
		_tmp25_ = width;
		_tmp22_ = _tmp25_;
	} else {
		gfloat _tmp26_;
		_tmp26_ = height;
		_tmp22_ = _tmp26_;
	}
	_tmp27_ = fixed_width;
	scale = _tmp27_ / _tmp22_;
	_tmp28_ = width;
	_tmp29_ = scale;
	width = _tmp28_ * _tmp29_;
	_tmp30_ = height;
	_tmp31_ = scale;
	height = _tmp30_ * _tmp31_;
	_tmp32_ = pixbuf;
	_tmp33_ = width;
	_tmp34_ = height;
	_tmp35_ = gdk_pixbuf_scale_simple (_tmp32_, (gint) _tmp33_, (gint) _tmp34_, GDK_INTERP_BILINEAR);
	_g_object_unref0 (pixbuf);
	pixbuf = _tmp35_;
	_tmp36_ = pixbuf;
	gtk_image_set_from_pixbuf ((GtkImage*) self, _tmp36_);
	gtk_widget_show ((GtkWidget*) self);
	_g_object_unref0 (pixbuf);
	return self;
}


IconWidget*
icon_widget_new (const gchar* icon_name_or_path,
                 GtkIconSize size)
{
	return icon_widget_construct (TYPE_ICON_WIDGET, icon_name_or_path, size);
}


static void
icon_widget_class_init (IconWidgetClass * klass)
{
	icon_widget_parent_class = g_type_class_peek_parent (klass);
}


static void
icon_widget_instance_init (IconWidget * self)
{
}


GType
icon_widget_get_type (void)
{
	static volatile gsize icon_widget_type_id__volatile = 0;
	if (g_once_init_enter (&icon_widget_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IconWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconWidget), 0, (GInstanceInitFunc) icon_widget_instance_init, NULL };
		GType icon_widget_type_id;
		icon_widget_type_id = g_type_register_static (gtk_image_get_type (), "IconWidget", &g_define_type_info, 0);
		g_once_init_leave (&icon_widget_type_id__volatile, icon_widget_type_id);
	}
	return icon_widget_type_id__volatile;
}



